#include<cstdio>
#include<cmath>
#include<cstdlib>

int N;
int deck[5000];
int c[5000][5000];
int p[5000];
int f(int i) {
	if(i<=2*N) return (i/2)*5 + i%5;
	if(i<=4*N) return (i/2-N)*5 + i%5 + 2;
	return (i-4*N)*5 + 4;
}

int sign(int a) {
	return a<0 ? -1 : a>0 ? 1 : 0;
}

void divide(int a, int b, int & q, int & r)  {
	q = a/b; r = a%b;
	while(r<0){r+=abs(b); q-=sign(b);}
	while(r>=abs(b)) {r-=abs(b); q+=sign(b);}
}

int extended_gcd(int a, int b, int& x, int & y) {
	if(b==0) {
		x=1; y=0; return a;
	}
	int q,r,s,t,d;
	divide(a,b,q,r);
	d = extended_gcd(b,r,s,t);
	x = t; y = s-q*t; return d;
}

int inverse(int a, int m) {
	int x,u;
	extended_gcd(a,m,x,u);
	divide(x,m,u,x);
	return x;
}


int gcd(int a,int b) {
	int x,y;
	return extended_gcd(a,b,x,y);
}

int lkkt(int a, int b ) {
	return a*b/gcd(a,b);
}


bool solve(int a0, int n0, int a1, int n1, int & r) {
	int d = gcd(n0,n1);
	if(a0%d != 0 || a1%d != 0) return false;
	
	a0/=d; a1/=d; n0/=d; n1/=d;
	
	int x0 = inverse(n0,n1);
	int x1 = inverse(n1,n0);
	int c0 = n0*x0;
	int c1 = n1*x1;
	r = a0*c1 + a1*c0;
	int dummy = 0;
	divide(r,n0*n1,dummy,r);
	return true;
}

bool solve(int a[5], int n[5], int & r) {
	int A = a[0];
	int N = n[0];
	for(int i=1;i<5;i++) {
		if(!solve(A,N,a[i],n[i],A)) return false;
		N = lkkt(N,n[i]);
		//van egy ilyenunk:   x === r (mod lkkt(N,n[i])
	}
	r = A;
	return true;
}


int main() {
	while(scanf("%d",&N)==1) {
		if(N==0) break;
		int minx = -1;
		int min = 0;
		for(int i=0; i<N; i++) {
			int x;
			scanf("%d",&x);
			deck[x] = f(i);
		}
		
		for(int i=0;i<5;i++) {
			p[i] = 0;
			c[i][p[i]++] = deck[i];
			for(int j = f(deck[i]); j!=deck[i]; j++) {
				c[i][p[i]++] = j;
			}
		}
		
		for(int x = 0; x<N; x++) {
			int t[5][5];
			int s[5] = {0,0,0,0,0};
			for(int i= 0; i<5; i++) { // els? t krtya
				for(int j = 0; j<p[i]; j++) {
					if(c[i][j]/5 == x)
						t[i][s[i]++] = j;
				}
			}
			if(s[0]==0 || s[1]==0 || s[2]==0 || s[3]==0 || s[4]==0) continue;
			
			int a[5];
#define FFOR(u) for(int (i##u) = 0; (i##u)<s[u]; (i##u)++) {a[u] = t[u][i##u];
			FFOR(0) FFOR(1) FFOR(2) FFOR(3) FFOR(4)
							int r;
							if(solve(a,p,r)) {
								if(minx==-1 || r<min) {min = r; minx = x;}
							}
			}}}}}
		}
		if(minx == -1) {
			printf("Neverending game.\n");
		} else {
			printf("Player %d wins game number %d\n",minx,min);
		}
	}
	return 0;
}