#include<cstdio>
#include<cstring>

typedef int INT;

#define int long long
#define abs(x) (((x)<0LL) ? (-(x)) : ((x)>0LL) ? (x) : 0)

int size;
int stack[5000];

bool push(int x) {
	if(x<-1000000000LL || x>1000000000LL) return false;
	stack[size++] = x;
	return true;
}

bool pop(int & x) {
	if(size==0) return false;
	x = stack[--size];
	return true;
}

#define POP(x) int x; if(!pop(x)) return false;

bool pop() {
	POP(x);
	return true;
}

bool clear() {
	size = 0;
	return true;
}

bool inv() {
	POP(x);
	return push(-x);
}

bool dup() {
	POP(x);
	push(x); push(x);
	return true;
}

bool swp() {
	POP(x);
	POP(y);
	push(x);
	push(y);
	return true;
}

bool add() {
	POP(x); POP(y);
	return push(y+x);
}

bool sub() {
	POP(x); POP(y);
	return push(y-x);
}

bool mul() {
	POP(x); POP(y);
	return push(x*y);
}

bool div() { // y/x
	POP(x); POP(y);
	if(x==0LL) return false;
	int q = abs(y)/abs(x);
	if(((y<0LL)&&(x>0LL)) || ((x<0LL)&&(y>0LL))) q = -q;
	return push(q);
}

bool mod() { // y%x
	POP(x); POP(y);
	if(x==0LL) return false;
	int r = abs(y)%abs(x);
	if(y<0LL) r = -r;
	return push(r);
}

typedef bool (*line)();

struct op{
	line what;
	int data;
	bool num;
	op(line what) : what(what), data(0LL), num(false) {}
	op(int data) : what(NULL), data(data), num(true) {}
	op() : what(NULL), data(0LL), num(false) {}
	bool exec() {
		if(num)
			return push(data);
		else
			return what();
	}
};

#define OPDEF(name,func) else if(strcmp(opname,name)==0) {program[line++] = op(func);}


INT main() {
	while(true) {
		op program[200000];
		int line = 0;
		while(true) {
			char opname[200];
			scanf("%s",opname);
			if(strcmp(opname,"QUIT")==0) return 0;
			if(strcmp(opname,"END")==0) break;
			
			if(strcmp(opname,"NUM")==0) {
				int x;
				scanf("%lld",&x);
				program[line++] = op(x);
			}
			OPDEF("POP",pop)
			OPDEF("INV",inv)
			OPDEF("DUP",dup)
			OPDEF("SWP",swp)
			OPDEF("ADD",add)
			OPDEF("SUB",sub)
			OPDEF("MUL",mul)
			OPDEF("DIV",div)
			OPDEF("MOD",mod)
		}
		int N;
		scanf("%lld",&N);
		
		for(int T=0; T<N; T++) {
			int x;
			scanf("%lld",&x);
			bool error = false;
			
			clear();
			push(x);
			for(int i=0;i<line;i++) {
				if(!program[i].exec()) {
					error = true;
					break;
				}
			}
			if(size != 1) error = true;
			if(error) {
				printf("ERROR\n");
			} else {
				pop(x);
				printf("%lld\n",x);
			}
		}
		printf("\n");
	}
}